/*
** Fitxer: salvrest.h
** Data: Agost 2002
** Autors: Sergio Blanco Cuaresma
**         Jonathan Hernndez Velasco
**         Valentin Rey Gmez
** Descripci: Capalera amb les funcions fetes en ensamblador per s del kernel.
**
*/

/*; Inicialitza una pila a la zona de memoria que li diguem
  ; guardant primer el flags i l'adrea de retorn del proces al
  ; que pertany la pila */
extern int *(iniPila(PTR direc,WORD sp,WORD ss));

/*; Guarda el context a la pila de l'ultim proces que s'estaba executant
  ; com que ha sigut interromput per una interrupcio, l'adrea a on s'ha quedat
  ; l'execuci esta a la pila, per tant, aprofitarem aquesta situaci
  ; * A la pila tindrem l'adrea de retorn de la RSI i la del proces interromput*/
extern int *(salvarContext(void));

/*; Restaurem context i amb iret saltarem al punt on va ser interromput el proces*/
extern void restaurarContext(int *);

/*Retorna el valor actual del registre AX*/
extern WORD obtenirAX(void);

/* Util per actualitzarBloquejats del teclat, canvia el registre AX 
   d'un pcb determinat */
extern void canviarAX(PTR direc,int longitud);

/* Retorna la tecla que estigui almacenada (s'ha de cridar des de la RSI del teclat,
   no des de cap altre banda) */
extern BYTE llegirTecla(void);