/*
** Fitxer: estruct.h
** Data: Agost 2002
** Autors: Sergio Blanco Cuaresma
**         Jonathan Hernndez Velasco
**         Valentin Rey Gmez
** Descripci: Capalera amb les estructures principal i constants tils per la configuraci
**             del kernel abans de compilar.
**
*/

#ifndef ESTRUCT_H
#define ESTRUCT_H

#include "cues.h"
#include "tipus.h"

#define FALSE 0
#define TRUE 1

// Codigos de estado
#define FREE 0
#define RDY 1
#define RUN 2
#define BLK 3
#define ASLEEP 4

// CONFIGURACI DEL NUCLI
#define MIDA_PILA 200
#define NPROC 20  // Nombre de processos mxim
#define NSEM 20 // Nombre de semafors que te el sistema
#define BUFFERTECLAT 200 // Nombre de caracters del buffer teclat
#define QUANTUM_CUA1 4
#define QUANTUM_CUA2 8


typedef struct TipusPCB
{
	struct item Fil;	// de cues.h
	int IdProces;
	int IdPCB;
	int Estat;
	PTR SS_SP;
	//PTR ss_sp[2];
	WORD pila[MIDA_PILA];
	int Dormir;	// Temps que ha de dormir quan esta en estat ASLEEP
	int Prioritat;
	int llegir;	// Quantitat de lletres que espera rebre al buffer teclat
	char *buffer;	// Punter al buffer que contindra el que ha demanat per teclat
	int QSencer[2];	// Historic de la ultima i penultima execuci:
				//	true: quantum utilitzat completament / false: contrari
} tPCB;

extern struct enviroment
{
  int dx,es,ds,di,si,bx,ax,cx,bp;
  long retTrap;		// Adrea de retorn del trap
  int flag;
  long retCridaSys;	// Adrea de retorn de la crida de sistema
};

typedef struct TipusSemafor
{
  struct cua cuaBLK;
  struct cua *pBLK;
  int id;
  int valor;
} tSemafor;

#endif
