/*
** Fitxer: procs.c
** Data: Agost 2002
** Autors: Sergio Blanco Cuaresma
**         Jonathan Hernndez Velasco
**         Valentin Rey Gmez
** Descripci: Mdul amb els processos de prova que fan us de les crides al sistema
**             proporcionades pel mdul crides.asm.
**
*/

#include "crides.h"
#include "pantalla.h"

// Ens serviran per saber l'identificador d'altres processos als que volem matar
int id_baix,id_mig,id_alt;

// RUTINES GENERALS QUE ES CARREGARAN DES D'ALTRES JOCS DE PROVA
void proc_a(void)
{
  char desp[]="Proc  : Em desperto i termino";
  int col=1;
  int color=3;
  char id;
  int i;

  EscriurePantalla("Proc ",5,1,col,INVERSE);
  id=QuiSoc();
  col=8;
  for (;;) {
    EscriurePantalla(&id,1,1,6,INVERSE);
    for(i=0;i<5000;i++);
    EscriurePantalla(&id,1,1,col,color);
    col++;
    if (col==78) {
      col=8;
      if (color==3){
        color=5;
      }else{
        color=3;
      }
    }
  }
}

void proc_b(void)
{
  int col=1;
  int color=3;
  char id;
  int i;

  EscriurePantalla("Proc ",5,3,col,INVERSE);
  id=QuiSoc();
  col=8;
  for (;;) {
    EscriurePantalla(&id,1,3,6,INVERSE);
    for(i=0;i<5000;i++);
    EscriurePantalla(&id,1,3,col,color);
    col++;
    if (col==78) {
      col=8;
      if (color==3){
        color=5;
      }else{
        color=3;
      }
    }
  }
}

void proc_c(void)
{
  int col=1;
  int color=3;
  char id;
  int i;

  EscriurePantalla("Proc ",5,5,col,INVERSE);
  id=QuiSoc();
  col=8;
  for (;;) {
    EscriurePantalla(&id,1,5,6,INVERSE);
    for(i=0;i<5000;i++);
    EscriurePantalla(&id,1,5,col,color);
    col++;
    if (col==78) {
      col=8;
      if (color==3){
        color=5;
      }else{
        color=3;
      }
    }
  }
}

void proc_d(void)
{
  int col=1;
  int color=3;
  char id;
  int i;

  EscriurePantalla("Proc ",5,7,col,INVERSE);
  id=QuiSoc();
  col=8;
  for (;;) {
    EscriurePantalla(&id,1,7,6,INVERSE);
    for(i=0;i<5000;i++);
    EscriurePantalla(&id,1,7,col,color);
    col++;
    if (col==78) {
      col=8;
      if (color==3){
        color=5;
      }else{
        color=3;
      }
    }
  }
}

void proc_e(void)
{
  int col=1;
  int color=3;
  char id;
  int i;

  EscriurePantalla("Proc ",5,9,col,INVERSE);
  id=QuiSoc();
  col=8;
  for (;;) {
    EscriurePantalla(&id,1,9,6,INVERSE);
    for(i=0;i<5000;i++);
    EscriurePantalla(&id,1,9,col,color);
    col++;
    if (col==78) {
      col=8;
      if (color==3){
        color=5;
      }else{
        color=3;
      }
    }
  }
}

void proc_f(void)
{
  int col=1;
  int color=3;
  char id;
  int i;

  EscriurePantalla("Proc ",5,11,col,INVERSE);
  id=QuiSoc();
  col=8;
  for (;;) {
    EscriurePantalla(&id,1,11,6,INVERSE);
    for(i=0;i<5000;i++);
    EscriurePantalla(&id,1,11,col,color);
    col++;
    if (col==78) {
      col=8;
      if (color==3){
        color=5;
      }else{
        color=3;
      }
    }
  }
}

// Proces orientat a cpu
void proc_cpu(void){
  int i=0;
  char id;
  
  EscriurePantalla("Proc ",5,1,1,INVERSE);
  id=QuiSoc();
  EscriurePantalla(&id,1,1,6,INVERSE);
  for (;;) {
    i=(i+1)%99999;
  }
}

// Proces amb calculs de cpu i E/S
void proc_mix(void)
{
  int col=1;
  int color=3;
  char id;
  int i,j;

  EscriurePantalla("Proc ",5,3,col,INVERSE);
  id=QuiSoc();
  col=8;
  for (;;) {
    EscriurePantalla(&id,1,3,6,INVERSE);
    for(i=0;i<5000;i++){
    	j=(j+1)%99999;
    }
    EscriurePantalla(&id,1,3,col,color);
    col++;
    if (col==78) {
      col=8;
      if (color==3){
        color=5;
        DormirProces(5);
      }else{
        color=3;
      }
    }
  }
}


// Proces orientat a E/S
void proc_es(void)
{
  int col=1;
  int color=3;
  char id;
  char tecla;
  int i;

  EscriurePantalla("Proc ",5,5,col,INVERSE);
  id=QuiSoc();
  col=8;
  for (;;) {
    EscriurePantalla(&id,1,5,6,INVERSE);
    EscriurePantalla(&id,1,5,col,color);
    col++;
    if (col==78) {
      col=8;
      if (color==3){
        color=5;
      }else{
        color=3;
        EscriurePantalla("Pressioni una tecla",19,6,1,NORMAL);
        LlegirTeclat(&tecla,1);
        EscriurePantalla(&tecla,1,6,21,NORMAL);
      }
    }
  }
}

///////////////////

// Joc de proves 1: Comprovaci del Round Robin
void jp1(void)
{
  CrearProces(proc_a,5);
  CrearProces(proc_a,5);
  CrearProces(proc_a,5);
  CrearProces(proc_a,5);
  CrearProces(proc_a,5);
  CrearProces(proc_a,5);
  DestruirProces(QuiSoc());
}

// Joc de proves 2: Comprovaci del Quantum
void jp2(void)
{
  CrearProces(proc_cpu,3);
  CrearProces(proc_mix,3);
  CrearProces(proc_es,3);
  DestruirProces(QuiSoc());
}

// Joc de proves 3: Comprovaci de prioritats
void jp3(void)
{
 CrearProces(proc_a,3);
 CrearProces(proc_b,4);
 CrearProces(proc_c,5);
 CrearProces(proc_d,6);
 CrearProces(proc_e,7);
 CrearProces(proc_f,8);
 DestruirProces(QuiSoc());
}


// Joc de proves 4: Comprovaci del DormirProces
void jp4_a(void)
{
  char dorm[]="Proc  : Em dormo";
  char desp[]="Proc  : Em desperto i termino";

  dorm[5]=QuiSoc();
  desp[5]=QuiSoc();
  EscriurePantalla(dorm,16,1,1,7);
  DormirProces(27);
  EscriurePantalla(desp,29,3,1,7);
  DestruirProces(QuiSoc());
}

void jp4_b(void)
{
  char dorm[]="Proc  : Em dormo";
  char desp[]="Proc  : Em desperto i termino";

  dorm[5]=QuiSoc();
  desp[5]=QuiSoc();
  EscriurePantalla(dorm,16,6,1,7);
  DormirProces(36);
  EscriurePantalla(desp,29,8,1,7);
  DestruirProces(QuiSoc());
}

void jp4_c(void)
{
  char dorm[]="Proc  : Em dormo";
  char desp[]="Proc  : Em desperto i termino";

  dorm[5]=QuiSoc();
  desp[5]=QuiSoc();
  EscriurePantalla(dorm,16,11,1,7);
  DormirProces(18);
  EscriurePantalla(desp,29,13,1,7);
  DestruirProces(QuiSoc());
}

void jp4(void)
{
 CrearProces(jp4_a,3);
 CrearProces(jp4_b,3);
 CrearProces(jp4_c,3);
 DestruirProces(QuiSoc());
}


// Joc de proves 5: Comprovaci de Prioritats i Apropiaci
void jp5_alt(void)
{
 int fil=3;
 int col=8;
 int color=3;
 char car[1]="a";
 char inici[]="Proces prioritat alta comena";
 char dorm[]="Proces prioritat alta es dorm";
 char desperta[]="Proces prioritat alta es desperta";
 char error[]="Codi retorn: -1 (proces no trobat)";
 char correcte[]="Codi retorn: 0 (proces destruit)";
 char dest_baix[]="Destrueix proces prioritat baixa ->";
 char dest_mig[]="Destrueix proces prioritat mitja ->";
 int codi;
 long i;
 char id;

 id=QuiSoc();
 EscriurePantalla(inici,30,2,1,7);
 for (i=0;i<1000;i++) {
    EscriurePantalla("Proc ",5,3,1,INVERSE);
    EscriurePantalla(&id,1,3,6,INVERSE);
    EscriurePantalla(&id,1,3,col,color);
    col++;
    if (col==78) {
      col=8;
      if (color==3){
        color=5;
      }else{
        color=3;
      }
    }

 }
 EscriurePantalla(dorm,30,4,1,7);
 DormirProces(180);
 EscriurePantalla(desperta,33,5,1,7);
 EscriurePantalla(dest_baix,35,6,1,7);
 codi=DestruirProces(id_baix);     // intenta destruir el proces baix
 if (codi!=0) EscriurePantalla(error,36,6,37,7);
 else EscriurePantalla(correcte,33,6,37,7);
 EscriurePantalla(dest_mig,35,7,1,7);
 codi=DestruirProces(id_mig);     // intenta destruir el proces mig
 if (codi!=0) EscriurePantalla(error,36,7,37,7);
 else EscriurePantalla(correcte,33,7,37,7);
 DestruirProces(QuiSoc());
}

void jp5_mig(void)
{
 int fil=13;
 int col=8;
 int color=3;
 char inici[]="Proces prioritat mitja comena";
 char car[1]="b";
 char id;

 id=QuiSoc();
 EscriurePantalla(inici,31,9,1,7);
 for (;;) {
    EscriurePantalla("Proc ",5,10,1,INVERSE);
    EscriurePantalla(&id,1,10,6,INVERSE);
    EscriurePantalla(&id,1,10,col,color);
    col++;
    if (col==78) {
      col=8;
      if (color==3){
        color=5;
      }else{
        color=3;
      }
    }

 }
}

void jp5_baix(void)
{
 int fil=18;
 int col=8;
 int color=3;
 char car[1]="c";
 char inici[]="Proces prioritat baixa comena";
 char error[]="Codi retorn: -1 (proces no trobat)";
 char correcte[]="Codi retorn: 0 (proces destruit)";
 char dest_mig[]="Destrueix proces prioritat mitja ->";
 int codi;
 long i;
 char id;

 id=QuiSoc();
 EscriurePantalla(inici,31,12,1,7);
 for (i=0;i<100000;i++) {
    EscriurePantalla("Proc ",5,13,1,INVERSE);
    EscriurePantalla(&id,1,13,6,INVERSE);
    EscriurePantalla(&id,1,13,col,color);
    col++;
    if (col==78) {
      col=8;
      if (color==3){
        color=5;
      }else{
        color=3;
      }
    }
 }

 EscriurePantalla(dest_mig,35,14,1,7);
 codi=DestruirProces(id_mig);	// intenta destruit el proces mig
 if (codi!=0) EscriurePantalla(error,36,14,37,7);
 else EscriurePantalla(correcte,33,14,37,7);
 for (;;);
}

void jp5(void)
{
  id_baix=CrearProces(jp5_baix,1);
  id_alt=CrearProces(jp5_alt,8);
  id_mig=CrearProces(jp5_mig,5);
  DestruirProces(QuiSoc());
}


// Joc de proves 6: Comprovaci del comportament dels semfors
void jp6_a(void)
{
 int col=1;
 int color=3;
 long i;
 char id;

 id=QuiSoc();
 EscriurePantalla("Proc ",5,1,col,INVERSE);
 EscriurePantalla(&id,1,1,6,INVERSE);
 col=8;
 for (;;) {
  WaitS(1);
  EscriurePantalla(&id,1,1,col,color);
  for (i=0;i<100000;i++);
    DormirProces(5);
    col++;
    if (col==78) {
      col=8;
      if (color==3){
        color=5;
      }else{
        color=3;
      }
    }

  SignalS(1);
 }
}

void jp6_b(void)
{
 int col=1;
 int color=3;
 long i;
 char id;

 id=QuiSoc();
 EscriurePantalla("Proc ",5,3,col,INVERSE);
 EscriurePantalla(&id,1,3,6,INVERSE);
 col=8;
 for (;;) {
  WaitS(1);
  EscriurePantalla(&id,1,3,col,color);
  for (i=0;i<100000;i++);
    DormirProces(5);
    col++;
    if (col==78) {
      col=8;
      if (color==3){
        color=5;
      }else{
        color=3;
      }
    }

  SignalS(1);
 }
}

void jp6_c(void)
{
 int col=1;
 int color=3;
 long i;
 char id;

 id=QuiSoc();
 EscriurePantalla("Proc ",5,5,col,INVERSE);
 EscriurePantalla(&id,1,5,6,INVERSE);
 col=8;
 for (;;) {
  WaitS(1);
  EscriurePantalla(&id,1,5,col,color);
  for (i=0;i<100000;i++);
    DormirProces(5);
    col++;
    if (col==78) {
      col=8;
      if (color==3){
        color=5;
      }else{
        color=3;
      }
    }

  SignalS(1);
 }
}

void jp6_d(void)
{
 int col=1;
 int color=3;
 long i;
 char id;

 id=QuiSoc();
 EscriurePantalla("Proc ",5,7,col,INVERSE);
 EscriurePantalla(&id,1,7,6,INVERSE);
 col=8;
 for (;;) {
  WaitS(1);
  EscriurePantalla(&id,1,7,col,color);
  for (i=0;i<100000;i++);
    DormirProces(5);
    col++;
    if (col==78) {
      col=8;
      if (color==3){
        color=5;
      }else{
        color=3;
      }
    }

  SignalS(1);
 }
}

void jp6_e(void)
{
 int col=1;
 int color=3;
 long i;
 char id;

 id=QuiSoc();
 EscriurePantalla("Proc ",5,9,col,INVERSE);
 EscriurePantalla(&id,1,9,6,INVERSE);
 col=8;
 for (;;) {
  WaitS(1);
  EscriurePantalla(&id,1,9,col,color);
  for (i=0;i<100000;i++);
    DormirProces(5);
    col++;
    if (col==78) {
      col=8;
      if (color==3){
        color=5;
      }else{
        color=3;
      }
    }

  SignalS(1);
 }
}

void jp6(void)
{
 IniSem(1,1);
 CrearProces(jp6_a,5);
 CrearProces(jp6_b,5);
 CrearProces(jp6_c,5);
 CrearProces(jp6_d,5);
 CrearProces(jp6_e,5);
 DestruirProces(QuiSoc());
}


// Joc de proves 7: Comprovaci del comportament del teclat
void jp7_a(void)
{
 char st_a[7];
 char quant_a[1];
 char dem_a[]="Proc  : Demano 7 caracters";
 char lle_a[]="Proc  : Llegits";
 char car_a[]="caracters ->";
 int cont_a;

 dem_a[5]=QuiSoc();
 lle_a[5]=QuiSoc();
 EscriurePantalla(dem_a,27,2,1,7);
 cont_a=LlegirTeclat(st_a,7);
 EscriurePantalla(lle_a,15,4,1,7);
 quant_a[0]=cont_a+'0';
 EscriurePantalla(quant_a,1,4,19,7);
 EscriurePantalla(car_a,13,4,21,7);
 EscriurePantalla(st_a,cont_a,4,34,7);
 DestruirProces(QuiSoc());
}

void jp7_b(void)
{
 char st_b[5];
 char quant_b[1];
 char dem_b[]="Proc  : Demano 5 caracters";
 char lle_b[]="Proc  : Llegits";
 char car_b[]="caracters ->";
 int cont_b;

 dem_b[5]=QuiSoc();
 lle_b[5]=QuiSoc();
 EscriurePantalla(dem_b,27,8,1,7);
 cont_b=LlegirTeclat(st_b,5);
 EscriurePantalla(lle_b,15,10,1,7);
 quant_b[0]=cont_b+'0';
 EscriurePantalla(quant_b,1,10,19,7);
 EscriurePantalla(car_b,13,10,21,7);
 EscriurePantalla(st_b,cont_b,10,34,7);
 DestruirProces(QuiSoc());
}

void jp7_c(void)
{
 char st_c[9];
 char quant_c[1];
 char dem_c[]="Proc  : Demano 9 caracters";
 char lle_c[]="Proc  : Llegits";
 char car_c[]="caracters ->";
 int cont_c;

 dem_c[5]=QuiSoc();
 lle_c[5]=QuiSoc();
 EscriurePantalla(dem_c,27,14,1,7);
 cont_c=LlegirTeclat(st_c,9);
 EscriurePantalla(lle_c,15,16,1,7);
 quant_c[0]=cont_c+'0';
 EscriurePantalla(quant_c,1,16,19,7);
 EscriurePantalla(car_c,13,16,21,7);
 EscriurePantalla(st_c,cont_c,16,34,7);
 DestruirProces(QuiSoc());
}

void jp7(void)
{
 CrearProces(jp7_a,5);
 CrearProces(jp7_b,5);
 CrearProces(jp7_c,5);
 DestruirProces(QuiSoc());
}


// Joc de proves 8: Comprovaci de la reutilitzaci dels PCBs
void jp8(void)
{
 char nopcb[]="PCBs exhaurits";
 char creant[]="Creant processos...";


 while (CrearProces(proc_a,5)!=-1) {
   EscriurePantalla(creant,19,4,1,7);
 }
 EscriurePantalla(nopcb,14,4,21,7);
 DestruirProces(QuiSoc());
  
 
}

// Joc de proves 9: Problema dels filosofs
void fil_1(void)
{
 long i;
 char pens[]="Pensant";
 char menj[]="Menjant";
 char espa[]="       ";
 char filo[]="Filosof  ";

 filo[8]=QuiSoc();
 EscriurePantalla(filo,9,1,1,7);
 for (;;)
 {
  EscriurePantalla(espa,7,1,12,7);
  EscriurePantalla(pens,7,1,12,BLAU);
  for (i=0;i<300000;i++);
  WaitS(1);
  WaitS(2);
  EscriurePantalla(espa,7,1,12,7);
  EscriurePantalla(menj,7,1,12,VERD);
  for (i=0;i<510000;i++);
  SignalS(1);
  SignalS(2);
 }

}

void fil_2(void)
{
 long i;
 char pens[]="Pensant";
 char menj[]="Menjant";
 char espa[]="       ";
 char filo[]="Filosof  ";

 filo[8]=QuiSoc();
 EscriurePantalla(filo,9,3,1,7);
 for (;;)
 {
  EscriurePantalla(espa,7,3,12,7);
  EscriurePantalla(pens,7,3,12,BLAU);
  for (i=0;i<120000;i++);
  WaitS(2);
  WaitS(3);
  EscriurePantalla(espa,7,3,12,7);
  EscriurePantalla(menj,7,3,12,VERD);
  for (i=0;i<400000;i++);
  SignalS(2);
  SignalS(3);
 }
}

void fil_3(void)
{
 long i;
 char pens[]="Pensant";
 char menj[]="Menjant";
 char espa[]="       ";
 char filo[]="Filosof  ";

 filo[8]=QuiSoc();
 EscriurePantalla(filo,9,5,1,7);
 for (;;)
 {
  EscriurePantalla(espa,7,5,12,7);
  EscriurePantalla(pens,7,5,12,BLAU);
  for (i=0;i<200000;i++);
  WaitS(3);
  WaitS(4);
  EscriurePantalla(espa,7,5,12,7);
  EscriurePantalla(menj,7,5,12,VERD);
  for (i=0;i<100000;i++);
  SignalS(3);
  SignalS(4);
 }

}

void fil_4(void)
{
 long i;
 char pens[]="Pensant";
 char menj[]="Menjant";
 char espa[]="       ";
 char filo[]="Filosof  ";

 filo[8]=QuiSoc();
 EscriurePantalla(filo,9,7,1,7);
 for (;;)
 {
  EscriurePantalla(espa,7,7,12,7);
  EscriurePantalla(pens,7,7,12,BLAU);
  for (i=0;i<520000;i++);
  WaitS(4);
  WaitS(5);
  EscriurePantalla(espa,7,7,12,7);
  EscriurePantalla(menj,7,7,12,VERD);
  for (i=0;i<400000;i++);
  SignalS(4);
  SignalS(5);
 }

}

void fil_5(void)
{
 long i;
 char pens[]="Pensant";
 char menj[]="Menjant";
 char espa[]="       ";
 char filo[]="Filosof  ";

 filo[8]=QuiSoc();
 EscriurePantalla(filo,9,9,1,7);
 for (;;)
 {
  EscriurePantalla(espa,7,9,12,7);
  EscriurePantalla(pens,7,9,12,BLAU);
  for (i=0;i<150000;i++);
  WaitS(1);
  WaitS(5);
  EscriurePantalla(espa,7,9,12,7);
  EscriurePantalla(menj,7,9,12,VERD);
  for (i=0;i<300000;i++);
  SignalS(1);
  SignalS(5);
 }
}

void jp9(void)
{
  IniSem(1,1);
  IniSem(2,1);
  IniSem(3,1);
  IniSem(4,1);
  IniSem(5,1);
  CrearProces(fil_1,5);
  CrearProces(fil_2,5);
  CrearProces(fil_3,5);
  CrearProces(fil_4,5);
  CrearProces(fil_5,5);
  DestruirProces(QuiSoc());
}
